# mycelial.technology

_glyph's website_

Handwritten CSS and HTML, images, an HTML splicer and an RSS generator.

## nyf

`src/main.rs`

An opinionated, custom-built HTML splicer. It reads HTML templates, splices them into a base template and writes the output.

Templates are expected at `./templates` and output is written to `./site`. The `./site` directory will be created if it doesn't exist.

A base template is expected at `./templates/base.html`. It must contain two tags: `[[ title ]]` and `[[ content ]]`.

The root index template is expected at `./templates/index.html`. All other templates are expected to be in sub-directories; for example: `./templates/plants/index.html` or `./templates/fungi/entomopathogens.html`.

The splicer crawls the sub-directories of `./templates`, reads each HTML file, splices it into the `[[ content ]]` tag of the base HTML template and writes the output to the `./site` directory (preserving the sub-directory structure). The contents of the `<h2>` element are spliced into the `[[ title ]]` tag of the base HTML template for each sub-directory template.

## RSS Generator

`src/bin/generate_rss.rs`

A custom RSS generator. It crawls the template sub-directories containing articles for syndication, extracts relevant information and writes the items to `./static/feed.rss`.

## License

[CC BY-NC-SA 4.0](https://creativecommons.org/licenses/by-nc-sa/4.0/)
